{
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
    utils.url = "github:numtide/flake-utils";
    naersk.url = "github:nix-community/naersk/master";
  };

  outputs =
    {
      self,
      nixpkgs,
      utils,
      naersk,
    }:
    utils.lib.eachDefaultSystem (
      system:
      let
        pkgs = import nixpkgs { inherit system; };
      in
      {
        devShell =
          with pkgs;
          mkShell.override { stdenv = pkgs.clangStdenv; } {
            nativeBuildInputs = [
              cargo
              rustc
              rustfmt
              rustPackages.clippy
              llvmPackages.bintools
              pkg-config
              duckdb
            ];
            buildInputs = [
              openssl
            ];
            shellHook = "export LD_LIBRARY_PATH=${duckdb}/lib";
            RUST_SRC_PATH = rustPlatform.rustLibSrc;
          };
      }
    );
}
